<template>
  <div class="ac-collection-grouped-card">
    <div
      v-show="is_loading"
      class="loader"
    >
      <img
        :src="loading_image"
        class="loader__image"
        alt="loader"
      >
    </div>

    <header class="ac__header">
      <!-- @slot Use this slot for header -->
      <slot name="header"></slot>
    </header>

    <main class="ac__body container-fluid">
      <component
        :is="dropdownElement"
        :data="add_reference(data)"
        :tabs_attrs="tabs_attrs"
        :align="get_tabs_align()"
      >
        <template #title="{ data }">
          <div
            class="group-header"
            @click="$emit('group-header-click', data)"
          >
            <!-- @slot Use this slot group_header for each item in response -->
            <slot name="group_header" :title="data.ref"></slot>
          </div>
        </template>

        <div
          v-for="(value, key, index) in data"
          :key="index"
          :slot="key"
          slot-scope="card_data"
          class="p-2"
        >
          <div class="ac__item__body">
            <b-row>
              <b-col
                v-for="(card, index) in card_data.data.data"
                :key="index"
                v-bind="col_options"
              >
                <ac-simple-card
                  ref="ac_simple_card"
                  :data="card"
                  :img="card[card_img] || ''"
                  :card_title="card_title"
                  :card_header="card_header"
                  :card_text="card_body"
                  :a_href="card_links"
                  :bulk="bulk"
                  v-bind="card_options"
                  @input="on_card_select"
                  @delete="$emit('delete', $event)"
                  @click="$emit('click', $event)"
                  @hover="$emit('hover', $event)"
                >
                  <template #hover>
                    <div
                      class="hover-div"
                      v-html="card_img_hover"
                    />
                  </template>

                  <template
                    v-if="card_footer"
                    #footer
                  >
                    {{ card[card_footer] }}
                  </template>
                </ac-simple-card>
              </b-col>
            </b-row>
          </div>
        </div>

        <!-- @slot Use this slot group_footer for each item in response -->
        <div class="group-footer">
          <slot name="group_footer"></slot>
        </div>
      </component>
    </main>

    <div
      v-show="load_more_type === 'loadMoreButton'"
      ref="loader_div"
      class="load-more text-center mt-2"
    >
      <!-- @slot Slot for load more buttom, shown only if load_more_type is 'loadMoreButton' -->
      <slot name="load_more_button"></slot>
    </div>

    <footer class="ac__footer">
      <!-- @slot Use this slot for footer -->
      <slot name="footer"></slot>
    </footer>
  </div>
</template>

<script>
import acCollectionCard from '../ac-collection-card.vue'
import acSimpleCard from '../ac-simple-card.vue'
import acAccordion from '../ac-accordion.vue'
import acTab from '../ac-tab.vue'

/**
 * ac collection grouped card component
 * @requires VueBootstrap
 * @requires ac-collection-card.vue
 * @requires ac-simple-card.vue
 * @requires ac-accordion.vue
 * @requires ac-tab.vue
 */

export default {
  name: 'ac-collection-grouped-card',

  extends: acCollectionCard,

  components: {
    acSimpleCard,
    acAccordion,
    acTab,
  },

  props: {
    /**
     * @param {string} group_key - Data from every request will be grouped with this key
     * Required
     */
    group_key: {
      type: String,
      required: true,
    },

    /**
     * @param {string} ac_type - Indicates in which style data will be displayed
     * Required
     */
    ac_type: {
      type: String,
      required: true,
      validator: value => ['horizontal-tab', 'vertical-tab', 'accordion'].indexOf(value) > -1,
    },

    /**
     * @param {object} ac_type - Attributes for tabs
     */
    tabs_attrs: {
      type: Object,
      required: false,
    },
  },

  computed: {
    dropdownElement() {
      return this.ac_type === 'accordion' ? 'ac-accordion' : 'ac-tab'
    },
  },

  methods: {
    /**
     * Triggets on card checkbox change
     * @function on_card_select
     * @param {string|number} event - checkbox value
     */
    on_card_select(event) {
      const index = this.selected.indexOf(event)
      if (index === -1) {
        this.selected.push(event)
      } else {
        this.selected.splice(this.selected.indexOf(event), 1)
      }
    },

    /**
     * Add reference for tab and accordion
     * @function add_reference
     * @param {object} obj - data
     */
    add_reference(obj) {
      return Object.keys(obj).map(key => ({
        ref: key,
        data: obj[key],
      }))
    },

    /**
     * Get tabs alignment
     * @function get_tabs_align
     */
    get_tabs_align() {
      return this.ac_type === 'vertical-tab' ? 'vertical' : 'horizontal'
    },
  },
}
</script>
